//:
#define ROWS 17
#define COLS 23

// :
#define MODE unsigned char
#define CHAR signed char
#define KEY unsigned int

// ࠢ:
#define NO_DIR 0x00
#define UP_DIR 0x01
#define LEFT_DIR 0x02
#define RIGHT_DIR 0x03
#define DOWN_DIR 0x04

// ࠭ 樨:
#define COPI 0x00
#define ANDI 0x01
#define XORI 0x02
#define ORI 0x03

// ⠭:
#define MAX_BUF  9
#define YES 0x01
#define NO 0x00
#define Font8_Step 8
#define Font8_Down 12
#define ShadowColor 0

// 㭪樨 BIOS:
#define Get_Key_BIOS       0x00  //㭪 BIOS 뢠  ⮩ .
#define Chack_Key_BIOS     0x02  //㭪 BIOS ஢ન ﭨ 

// :
#define LEFT    0x4b00
#define RIGHT   0x4d00
#define CTRL_LEFT    0x7300
#define CTRL_RIGHT   0x7400
#define ESC     0x001b
#define DOWN    0x5000
#define UP      0x4800
#define PAGE_UP 0x4900
#define PAGE_DO 0x5100
#define HOME    0x4700
#define END     0x4F00
#define INS     0x5200
#define DEL     0x5300
#define F1      0x3B00
#define F2      0x3C00
#define F3      0x3D00
#define F4      0x3E00
#define F5      0x3F00
#define F6      0x4000
#define F10     0x4400
#define TAB     0x0009
#define ENTER   0x000D
#define CTRL_UP 0x8400
#define CTRL_DO 0x7600
#define S_TAB   0x0F00
#define S_BAR   0x0020
#define START   0x0001
#define BS      0x0008

// -㭪樨:
#define min(a,b) ((a<b)?(a):(b))
#define max(a,b) ((a>b)?(a):(b))
#define abs(a) ((a>0)?(a):(-(a)))

// 㭪樨 ࠡ  䨪:
extern int initgraph (void);
extern void savemode (char Do);

extern void putpixel (int X, char Y, char C);
extern char getpixel (int X, char Y);

extern void line (int X1,char Y1,int X2,char Y2,char C);
extern void rectangle (int x1,char y1, int x2, char  y2,char color);
extern void bar (int X1, int Y1, int X2, int Y2, char C);

extern unsigned imagesize (int x1, int y1, int x2, int y2);
extern void getimage (int x1, char y1, int x2, char y2, char *bm);
extern void putimage (int x1, char y1, int x2, char y2, char *bm);
extern void outtext8 (int X,char Y,char C,char far *Mes);
//extern void sqrimage (int X,int Y,char *Icon,int Size,char Mode);
extern void chand (int X1,int Y1,int X2,int Y2,char Color,char Op);

extern KEY  Get_Key( void );
extern void Set_Key( KEY kol, ... );
extern void Clear_Buf( void );
extern KEY Hit_Key (void);

extern void Window (int X1, int Y1, int X2, int Y2, char BorderColor,char WinColor);
extern void Print( int x, int y, MODE color1, MODE color2, MODE far *s);
extern void setallpalette (void);
extern MODE ReadPalette(void);
extern void setpalette (int,char,char,char);
extern MODE ReadPCX (char *fname);

extern MODE Ask (MODE *);
extern void MoveSelector (int,int,int,int,int);
extern void GetDate (void);
extern void GetTime (void);

#define BEST_TABLE_LEN 10
struct BEST { //24 ;   ப
 MODE Name[12];        // ப
 unsigned long Score,  //
	       Level;  //஢
 MODE Day, Mon;
 unsigned Year;  //, , 
};

struct Object { //ꥪ 
 int Row,Col;  //ப  ⮫ ࠭
 MODE Dir,     //ࠢ 
      SprNum;  // ࠩ
 CHAR TurnDir; //㤠  Speedman'
	       // 砯 - ।   
};

struct Game {
 unsigned long CurLevel, // ⥪饣 ஢ 1
	       AllLevels, // ⥪饣 ஢  ⮬ 横 1
	       CurColor; // ⥪饣  梥⮢ 1
 MODE Sound; // ./몫. 1
 MODE Agressive; //ᨢ 砯 1

 MODE Lives; //⢮  3
 int MainDelay; //᭮ প   18
 int All; //쪮 㦭 ᮡ  ஢ 182

 unsigned long Score; //騩  0
 MODE Bombs; //⢮  0
 MODE Eated; //ꥤ 砯   横 0
 MODE Effect; //  䥪 0
 MODE CurChap; //饥 ᫮ 砯 0
 MODE InPort; //宦   0
 MODE BombBuf,GetBomb; //࠭   祭  ਧ  0 0
 MODE BonusBuf,GetBonus; //࠭  ਧ 祭  ਧ ਧ 0 0
 int BombRow,BombCol; //ப  ⮫  ,   .. 0 0
 int BonusRow,BonusCol; //ப  ⮫  ਧ 0 0

 int      ActivateTime,  //६ ⨢樨 砯, ᥪ.
	  AgressiveTime, //६  ᨢ, ᥪ.
	  BombTime, //६ ⢮ 
	  BonusTime, //६ ⢮ 
	  EffectTime; //६ ⢨ ᯥ. 䥪  ஢
};

struct Fix {
 int ActivateTime,
     AgressiveTime,
     BombTime,
     BonusTime,
     EffectTime;
};

#define GAME_SIZE 503
